<?php
	// gestion d'une table d'articles
  include "config.php";
  include "articles.php";  
 
  // session
  session_start();
  $dSession=$_SESSION["session"];
  // action  entreprendre
  $sAction=$_POST["action"] ? $_POST["action"] : $_GET["action"] ? $_GET["action"] : "authentifier";
  $sAction=strtolower($sAction);
  // phase ventuelle
  $sPhase=$_POST["phase"] ? $_POST["phase"] : $_GET["phase"] ? $_GET["phase"] : "0";

	// faut-il prsenter la page d'authentification ?  
  if(! isset($dSession)){
  	// authentification de l'utilisateur
    if($sAction=="authentifier" && $sPhase=="0") authentifier_0($dConfig);
    if($sAction=="authentifier" && $sPhase=="1") authentifier_1($dConfig);   
    if($sAction=="authentifier" && $sPhase=="2") authentifier_2($dConfig);    
    // action anormale
    authentifier_0($dConfig);        
  }//if - pas de session
     
	// on rcupre la session
  $dSession=unserialize($dSession);

	// l'enchanement des actions est-il normal ?
  if( ! enchainementOK($dConfig,$dSession,$sAction,$sPhase)){
    // enchanement anormal
    authentifier_0($dConfig);        
  }//if - pas de session
     
	// traitement des actions
  if($sAction=="authentifier"){
   if($sPhase=="1") authentifier_1($dConfig,$dSession);  
   if($sPhase=="2") authentifier_2($dConfig,$dSession);  
  }//if     
  if($sAction=="addarticle"){
   if($sPhase=="0") addArticle_0($dConfig,$dSession);
   if($sPhase=="1") addArticle_1($dConfig,$dSession);   
   if($sPhase=="2") addArticle_2($dConfig,$dSession);
  }//if   
  if($sAction=="updatearticle"){
   if($sPhase=="0") updateArticle_0($dConfig,$dSession);
   if($sPhase=="1") updateArticle_1($dConfig,$dSession);
   if($sPhase=="2") updateArticle_2($dConfig,$dSession);  
   if($sPhase=="3") updateArticle_3($dConfig,$dSession);   
 	}//if
  if($sAction=="deletearticle"){
    if($sPhase=="0") deleteArticle_0($dConfig,$dSession);
   	if($sPhase=="1") deleteArticle_1($dConfig,$dSession);
  	if($sPhase=="2") deleteArticle_2($dConfig,$dSession);
	}//if
  if($sAction=="selectarticle"){
    if($sPhase=="0") selectArticle_0($dConfig,$dSession);
   	if($sPhase=="1") selectArticle_1($dConfig,$dSession);    
  	if($sPhase=="2") selectArticle_2($dConfig,$dSession);
  }//if
  if($sAction=="sql"){
    if($sPhase=="0") sql_0($dConfig,$dSession);
   	if($sPhase=="1") sql_1($dConfig,$dSession);    
  	if($sPhase=="2") sql_2($dConfig,$dSession);
	}//if
              
	// action errone - on prsente la page d'authentification
  // par prcaution - ce cas ne devrait pas se produire
  authentifier_0($dConfig,"0");
  
  // fin
  exit(0);

  // ---------------------------------------------------------------
  function enchainementOK(&$dConfig, &$dSession, $sAction, $sPhase){
  	// vrifie si l'action en cours peut suivre l'action prcdente
		// rend TRUE si c'est le cas, FALSE sinon
    
    // infos de l'tape prcdente
    $dPrec=$dSession["prcdent"];
    $sURIprec1=$dSession["uri"];
    
    // infos de l'tape actuelle
    $dSession["prcdent"]=array("action"=>$sAction,"phase"=>$sPhase);
    $dSession["uri"]=$_SERVER["REQUEST_URI"];
        
    // uri prcdente dans le referer
    preg_match("/^http:\/\/.+?\/(.+?)$/i",$_SERVER["HTTP_REFERER"],$champs);
    $sURIprec2="/$champs[1]";
  
    // il faut que les deux URI prcdentes soient gales
    if($sURIprec1!=$sURIprec2) return FALSE; 

		// ce n'est pas suffisant - le HTTP_REFERER a pu tre construit par un client programm
    // on vrifie l'enchanement des actions avec le dictionnaire$dConfig['prcdents']
    $aPrcdents=$dConfig['prcdents'][$sAction][$sPhase];
    
    // si l'action en cours n'est pas dans le dictionnaire, c'est qu'elle est toujours possible
    if(! isset($aPrcdents)) return TRUE;
    
		// on parcourt la liste des actions prcdentes possibles
    // pour y trouver l'action prcdente rellement accomplie $dPrec
    for($i=0;$i<count($aPrcdents);$i++){
    	if($dPrec['action']==$aPrcdents[$i]['action'] && $dPrec['phase']==$aPrcdents[$i]['phase'])
      	return TRUE;
   	}//for
    
    // on n'a pas trouv
    return FALSE;
  }//enchainementsOK         
	           
  // ---------------------------------------------------------------
  function finSession(&$dSession){
  	//$dSession : dictionnaire contenant les infos de session
    $_SESSION["session"]=serialize($dSession);
    session_write_close();
  }//finsession      

  // ---------------------------------------------------------------
  function authentifier_0(&$dConfig){
  	// processus d'authentification d'un utilisateur
    // $dConfig : dictionnaire de configuration de l'application

		// s'il y a une session - on la dtruit
    session_destroy();
        
    // on rcupre les caractristiques de la page principale
    $main=$dConfig["main"];
      
  	// page d'identification
  	$main["title"]="Gestion d'articles";
    $main["contenu"]=$dConfig["urlPageLogin"];
    $main["lgende"]="Connexion  la base";
		$main["post"]=$dConfig["urlAppArticles"]."?action=authentifier&phase=1";      
    $main["login"]=$sLogin;

		// on prsente la page principale
		include $dConfig["urlPageMain"];
		// fin
		exit(0);
  }//authentifier-0

  // ---------------------------------------------------------------
  function authentifier_1(&$dConfig){
  	// phase 1 du processus d'authentification d'un utilisateur
    // $dConfig : dictionnaire de configuration de l'application
    
    // on rcupre les caractristiques de la page principale
    $main=$dConfig["main"];
      
  	// on rcupre les paramtres sur l'identit de l'utilisateur
  	$sLogin=$_POST["txtLogin"];
  	$sMdp=$_POST["txtMdp"];

    // si le login est vide, on n'insiste pas
    if(trim($sLogin)=="") authentifier_0($dConfig);
    
  	// cration d'un objet articles
  	$oArticles=new articles($dConfig["DSN"],$sLogin,$sMdp);
  	// des erreurs ?
  	if(count($oArticles->aErreurs)!=0){
  		// page d'erreurs
  		$main["title"]="Gestion d'articles";    		
  		$main["erreurs"]=$oArticles->aErreurs;
    	$main["contenu"]=$dConfig["urlPageErreurs"];
    	$main["lgende"]="Authentification : erreurs";
      $main["href"]= $dConfig["urlAppArticles"]."?action=authentifier&phase=2&txtLogin=".$sLogin;
      $main["lien"]="Retour  la page de login";
			// on prsente la page principale
			include $dConfig["urlPageMain"];
			// fin
			exit(0);
  	}//if

		// c'est bon - la connexion  la base est faite et l'utilisateur est identifi
		$main["title"]="Gestion d'articles ($sLogin";
		$main["title"].=$oArticles->bAdmin ? " - administrateur)" : " - utilisateur)";
    $main["infos"]="Vous tes connect  la base des articles.";
  	$main["contenu"]=$dConfig["urlPageInfos"];
  	$main["lgende"]="Connexion russie";

    // on calcule les liens de la page
    $sSessionId=ini_get('session.name')."=".session_id();
    $aLiens=array_keys($main["liens"]);
    for($i=0;$i<count($aLiens);$i++){
    	$main["liens"][$aLiens[$i]].="&$sSessionId";
    }//for

		// on enregistre diverses valeurs dans la session
		$dSession["articles"]=$oArticles;
    $dSession["main"]=$main;
    $dSession['id']=$sSessionId;
    $dSession['uri']=$_SERVER['REQUEST_URI'];

		// on enregistre la session
		finSession($dSession);

  	// on prsente la page principale
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);
	}//authentifier-1

  // ---------------------------------------------------------------
  function authentifier_2(&$dConfig,$dSession){
  	// phase 2 du processus d'authentification d'un utilisateur
    // $dConfig : dictionnaire de configuration de l'application
    
    // on rcupre les caractristiques de la page principale
    $main=$dConfig["main"];
    
  	// page d'identification
  	$main["title"]="Gestion d'articles";
    $main["contenu"]=$dConfig["urlPageLogin"];
    $main["lgende"]="Connexion  la base";
		$main["post"]=$dConfig["urlAppArticles"]."?action=authentifier&phase=1";      
    $main["login"]=$_GET['txtLogin'];

		// on prsente la page principale
		include $dConfig["urlPageMain"];
		// fin
		exit(0);
  }//authentifier-2
  
  //--------------------------------------------------------------------
  function addArticle_0($dConfig,$dSession){
    // phase 0 de l'ajout d'un article

  	// rcupration de l'environnement
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // prparation de la page
    $main["lgende"]="Ajouter un nouvel article";
  	$main["contenu"]=$dConfig["urlPageAddArticle"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=addArticle&phase=1&$sSessionId";
    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);     
  }//addArticle-0

  //--------------------------------------------------------------------
  function addArticle_1($dConfig,$dSession){
    // phase 1 de l'ajout d'un article

    // on rcupre des donnes de la session
    $oArticles=$dSession['articles'];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];
  
  	// on rcupre les donnes du post
    $dArticle=$_POST["article"];
    // on mmorise l'article
    $dSession["article"]=$dArticle;
		finSession($dSession);
    // dictionnaire des erreurs
    $dErreurs=array(
    	"lgende"=>"Ajouter un nouvel article : erreurs",
      "href"=>$dConfig["urlAppArticles"]."?action=addArticle&phase=2&$sSessionId",
      "lien"=>"Retour  la page d'ajout d'article");
          
		// on cre une connexion  la base
    $oArticles->connect();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if

    // on ajoute l'article
    $oArticles->addArticle($dArticle);
    
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if
    
  	// c'est bon
  	$main["lgende"]="Ajouter un nouvel article";
    $main["infos"]="Ajout russi";
		$main["contenu"]=$dConfig["urlPageInfos"];
    // on prsente la page principale
		finSession($dSession);
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);                
  }//addArticle-1  

  //--------------------------------------------------------------------
  function addArticle_2($dConfig,$dSession){
    // phase 2 de l'ajout d'un article

  	// rcupration de l'environnement
    $sSessionId=$dSession["id"];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];
    $main['article']=$dSession['article'];
    
    // prparation de la page
    $main["lgende"]="Ajouter un nouvel article";
  	$main["contenu"]=$dConfig["urlPageAddArticle"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=addArticle&phase=1&$sSessionId";
    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);     
  }//addArticle-2
  
  //--------------------------------------------------------------------
  function updateArticle_0($dConfig,$dSession){
  	// rcupration de l'environnement
    $oArticles=$dSession["articles"];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // dictionnaire des erreurs
    $dErreurs=array("lgende"=>"Modifier un article : erreurs");
          
		// on cre une connexion  la base
    $oArticles->connect();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if
    
  	// on rcupre les codes des articles
    $aCodes=$oArticles->getCodes();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if
    
    // prparation de la page
    $main["codes"]=$aCodes;
    $main["lgende"]="Modifier un article existant";
  	$main["contenu"]=$dConfig["urlPageUpdateArticle1"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=updateArticle&phase=1&$sSessionId";
    
    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);     
  }//updateArticle-0  

  //--------------------------------------------------------------------
  function updateArticle_1($dConfig,$dSession){
  	// rcupration de l'environnement
    $oArticles=$dSession["articles"];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // dictionnaire des erreurs
    $dErreurs=array("lgende"=>"Modifier un article : erreurs");
          
		// on cre une connexion  la base
    $oArticles->connect();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if
    
  	// on rcupre le code choisi par l'utilisateur
    $sCodeArticle=$_POST["cmbCodeArticle"];
    
    // at-on un code ?
    if (! $sCodeArticle){
    	// on affiche les erreurs
      $dErreurs['erreurs']="Vous n'avez pas indiqu le code de l'article  modifier";
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if erreur

    // a-t-on un code valide ?
    $dSelect=array("colonnes"=>"code,nom,prix,stockActuel,stockMinimum",
    	"where"=>"code='".addslashes($sCodeArticle)."'");        
    $oArticles->selectArticles($dSelect);
    
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']="Le code $sCodeArticle n'existe pas";
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if erreur

    // on a un code valide - on rcupre la fiche
    $dArticle=$oArticles->oRsultats->fetchRow(DB_FETCHMODE_ASSOC);

    // prparation de la page de modification
    $main["article"]=$dArticle;
    $main["lgende"]="Modifier un article";
  	$main["contenu"]=$dConfig["urlPageUpdateArticle2"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=updateArticle&phase=2&$sSessionId";

    // on mmorise le code dans la session
    $dSession["codeArticle"]=$sCodeArticle;
    finSession($dSession);

    // on prsente la page principale
		finSession($dSession);    
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);         
  }//updateArticle-1  

  //--------------------------------------------------------------------
  function updateArticle_2($dConfig,$dSession){
  	// rcupration de l'environnement
    $oArticles=$dSession["articles"];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // dictionnaire des erreurs
    $dErreurs=array(
    	"lgende"=>"Modifier un article : erreurs",
      "href"=>$dConfig["urlAppArticles"]."?action=updateArticle&phase=3&$sSessionId",
      "lien"=>"Retour  la page de modification d'article");
          
		// on cre une connexion  la base
    $oArticles->connect();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if
    
  	// on rcupre le code choisi par l'utilisateur
    $sCodeArticle=$dSession["codeArticle"];
    
    // on rcupre l'article
    $dArticle=$_POST["article"];
    $dArticle["code"]=$sCodeArticle;
    
    // on le mmorise dans la session
    $dSession["article"]=$dArticle;
    finSession($dSession);
    
    // on fait la modification
    $oArticles->modifyArticle($dArticle);
    
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if

    // la modification s'est bien passe
  	$main["lgende"]="Modifier un article";
    $main["infos"]="Modification russie";
		$main["contenu"]=$dConfig["urlPageInfos"];

    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);                
  }//updateArticle-2  

  //--------------------------------------------------------------------
  function updateArticle_3($dConfig,$dSession){
  	// cas d'une modification rate

  	// rcupration de l'environnement
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];
    
    // on rcupre l'article dans la session
		$main["article"]=$dSession["article"];

    // prparation de la page de modification
    $main["lgende"]="Modifier un article";
  	$main["contenu"]=$dConfig["urlPageUpdateArticle2"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=updateArticle&phase=2&$sSessionId";

    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);         
  }//updateArticle-3
  
  //--------------------------------------------------------------------
  function deleteArticle_0($dConfig,$dSession){
		// suppression d'un article
    
  	// rcupration de l'environnement
    $oArticles=$dSession["articles"];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // dictionnaire des erreurs
    $dErreurs=array("lgende"=>"Supprimer un article : erreurs");
          
		// on cre une connexion  la base
    $oArticles->connect();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if
    
  	// on rcupre les codes des articles
    $aCodes=$oArticles->getCodes();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if
      
    // prparation de la page
    $main["codes"]=$aCodes;
    $main["lgende"]="Supprimer un article";
  	$main["contenu"]=$dConfig["urlPageDeleteArticle1"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=deleteArticle&phase=1&$sSessionId";
    
    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);     
  }//deleteArticle-0  

  //--------------------------------------------------------------------
  function deleteArticle_1($dConfig,$dSession){
		// suppression d'un article
    
  	// rcupration de l'environnement
    $oArticles=$dSession["articles"];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // dictionnaire des erreurs
    $dErreurs=array("lgende"=>"Supprimer un article : erreurs");
          
		// on cre une connexion  la base
    $oArticles->connect();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if

  	// on rcupre le code choisi par l'utilisateur
    $sCodeArticle=$_POST["cmbCodeArticle"];
    
    // at-on un code ?
    if (! $sCodeArticle){
    	// on affiche les erreurs
      $dErreurs['erreurs']="Vous n'avez pas indiqu le code de l'article  suprimer";
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if erreur

    // a-t-on un code valide ?
    $dSelect=array("colonnes"=>"code,nom,prix,stockActuel,stockMinimum",
    	"where"=>"code='".addslashes($sCodeArticle)."'");        
    $oArticles->selectArticles($dSelect);
    
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']="Le code $sCodeArticle n'existe pas";
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if erreur

    // on a un code valide - on rcupre la fiche
    $dArticle=$oArticles->oRsultats->fetchRow(DB_FETCHMODE_ASSOC);

    // prparation de la page de modification
    $main["article"]=$dArticle;
    $main["lgende"]="Supprimer un article";
  	$main["contenu"]=$dConfig["urlPageDeleteArticle2"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=deleteArticle&phase=2&$sSessionId";

    // on mmorise l'article dans la session
    $dSession["article"]=$dArticle;

    // on prsente la page principale
		finSession($dSession);    
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);         
  }//deleteArticle-1  

  //--------------------------------------------------------------------
  function deleteArticle_2($dConfig,$dSession){
		// suppression d'un article
    
  	// rcupration de l'environnement
    $oArticles=$dSession["articles"];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // dictionnaire des erreurs
    $dErreurs=array("lgende"=>"Supprimer un article : erreurs");
          
		// on cre une connexion  la base
    $oArticles->connect();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if
    
  	// on rcupre l'article choisi par l'utilisateur
    $dArticle=$dSession["article"];
    
    // on fait la suppression
    $oArticles->deleteArticle($dArticle['code']);
    
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if

    // la suppression s'est bien passe - on prpare la page principale
  	$main["lgende"]="Supprimer un article";
    $main["infos"]="Suppression russie";
		$main["contenu"]=$dConfig["urlPageInfos"];
    
    // on prsente la page principale
		finSession($dSession);
  	include $dConfig["urlPageMain"];

    	// fin
    	exit(0);                
	}//deleteArticle_2    
  
  //--------------------------------------------------------------------
  function selectArticle_0($dConfig,$dSession){
		// slection d'articles
    
  	// rcupration de l'environnement
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // prparation de la page
    $main["lgende"]="Slectionner des articles";
  	$main["contenu"]=$dConfig["urlPageSelectArticle1"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=selectArticle&phase=1&$sSessionId";

    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];

  	// fin
  	exit(0);     
  }//selectArticle_0  

  //--------------------------------------------------------------------
  function selectArticle_1($dConfig,$dSession){
		// slection d'articles
    
  	// rcupration de l'environnement
    $oArticles=$dSession["articles"];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // dictionnaire des erreurs
    $dErreurs=array("lgende"=>"Slectionner des articles : erreurs");
          
		// on cre une connexion  la base
    $oArticles->connect();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if

  	// on rcupre les donnes du POST
    $dSelect=$_POST["select"];

		// on les mmorise dans la session
    $dSession['select']=$dSelect;
          
    // on excute le select
    $oArticles->selectArticles($dSelect);
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs["href"]=$dConfig["urlAppArticles"]."?action=selectArticle&phase=2&$sSessionId";
      $dErreurs["lien"]="Retour  la page de slection d'articles";               
      $dErreurs['erreurs']=$oArticles->aErreurs;
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if

    // affichage du rsultat
    $main["lgende"]=$oArticles->sQuery;
    $main["rsultats"]=$oArticles->oRsultats;
  	$main["contenu"]=$dConfig["urlPageSelectArticle2"];
    $main["href"]=$dConfig["urlAppArticles"]."?action=selectArticle&phase=2&$sSessionId";
    $main["lien"]="Retour  la page de slection d'articles";               
		finSession($dSession);
  	include $dConfig["urlPageMain"];

  	// fin
  	exit(0);     
	}//selectArticle_1  

  //--------------------------------------------------------------------
  function selectArticle_2($dConfig,$dSession){
		// slection d'articles
    
  	// rcupration de l'environnement
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

  	// on rcupre le slect
    $main["select"]=$dSession["select"];

    // prparation de la page
    $main["lgende"]="Slectionner des articles";
  	$main["contenu"]=$dConfig["urlPageSelectArticle1"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=selectArticle&phase=1&$sSessionId";

    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];

  	// fin
  	exit(0);     
  }//selectArticle_2  
  
  //--------------------------------------------------------------------
  function sql_0($dConfig,$dSession){
		// mission d'une requte sql quelconque

  	// rcupration de l'environnement
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];
   
    // prparation de la page
    $main["lgende"]="Excution d'une requte SQL";
  	$main["contenu"]=$dConfig["urlPageSQL1"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=sql&phase=1&$sSessionId";

    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);     
  }//sql_0  

  //--------------------------------------------------------------------
  function sql_1($dConfig,$dSession){
		// mission d'une requte sql quelconque
  
  	// rcupration de l'environnement
    $oArticles=$dSession["articles"];
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];

    // dictionnaire des erreurs
    $dErreurs=array(
    	"lgende"=>"SQL : erreurs",
      "href"=>$dConfig["urlAppArticles"]."?action=sql&phase=2&$sSessionId",
      "lien"=>"Retour  la page d'mission de requtes SQL");            	                             
               
		// on cre une connexion  la base
    $oArticles->connect();
    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
      finSession($dSession);
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if
  
  	// on rcupre la requte SQL
    $sSqlText=$_POST['sqlText'];
    
    // on mmorise la requte
    $dSession['sqlText']=$sSqlText;
    finSession($dSession);
    
		// on l'excute
    $oArticles->execute($sSqlText,FALSE);

    // des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// on affiche les erreurs
      $dErreurs['erreurs']=$oArticles->aErreurs;
    	afficheErreurs($dErreurs,$dConfig,$dSession);
    }//if erreur
  
    // pas d'erreur
    $main["lgende"]="Excution d'une requte SQL : rsultats";
    
    // quel tait le type de la requte ?
    preg_match("/^\s*(.+?)\s+/",$oArticles->sQuery,$champs);
    $requte=strtolower($champs[1]);

    // select
		if($requte=="select"){
    	// rsultat de la requte select     
      $main['rsultats']=$oArticles->oRsultats;        
      // noms des colonnes obtenues
			$dInfos=$oArticles->oRsultats->tableInfo();
      while(list($cl,$val)=each($dInfos)){
      	// $val est un dictionnaire
        $main['colonnes'][]=$val['name'];
      }//while     
    	$main["contenu"]=$dConfig["urlPageSQL2"];
		}else{
      // insert, delete, update
      $dUpdates=array("insert"=>1,"delete"=>1,"update"=>1);
			if(array_key_exists($requte,$dUpdates)){
      	// nombre de lignes "affectes"
        $main["infos"]=$oArticles->oDB->affectedRows()." ligne(s) ont t traites par la commande";     
      	$main["contenu"]=$dConfig["urlPageSQL3"];
			}
      else{
      	// autres cas
        $main["infos"]="Excution russie";     
      	$main["contenu"]=$dConfig["urlPageSQL3"];
      }//if
    }//if

		// affichage de la page des rsultats
    $main["href"]=$dConfig["urlAppArticles"]."?action=sql&phase=2&$sSessionId";
    $main["lien"]="Retour  la page d'mission de requtes SQL";
		finSession($dSession);                	                     
  	include $dConfig["urlPageMain"];

  	// fin
  	exit(0);  
  }//sql_1

  //--------------------------------------------------------------------
  function sql_2($dConfig,$dSession){
		// mission d'une requte sql quelconque

  	// rcupration de l'environnement
    $main=$dSession["main"];
    $sSessionId=$dSession["id"];
   
    // prparation de la page
    $main['sqlText']=$dSession['sqlText'];
    $main["lgende"]="Excution d'une requte SQL";
  	$main["contenu"]=$dConfig["urlPageSQL1"];
    $main["post"]=$dConfig["urlAppArticles"]."?action=sql&phase=1&$sSessionId";

    // on prsente la page principale
    finSession($dSession);
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);     
  }//sql_2  
  
  //--------------------------------------------------------------------
  function afficheErreurs($dErreurs,$dConfig,$dSession){
  	// prparation de la page
    $main=$dSession['main'];     
    $main["lgende"]=$dErreurs['lgende'];
    $main["erreurs"]=$dErreurs['erreurs'];
    $main['href']=$dErreurs['href'];
    $main['lien']=$dErreurs['lien'];
  	$main["contenu"]=$dConfig["urlPageErreurs"];
    // on prsente la page principale
		finSession($dSession);    
  	include $dConfig["urlPageMain"];
  	// fin
  	exit(0);
  }//afficheErreurs

  //--------------------------------------------------------------------
  function suivi($dInfos){
  	// affiche un dictionnaire d'informations
    while(list($cl,$valeur)=each($dInfos)){
    	echo "[$cl,$valeur]<br>\n";
    }//while
  }//suivi
?>
      