<?php
	
  // bibliothque
  require_once "articles.php";
  require_once "DB.php";
  
	// test de la classe articles

	// configuration base articles
	$dDSN=array(
		"sgbd"=>"mysql",
		"admin"=>"admarticles",
		"mdpadmin"=>"mdparticles",
		"host"=>"localhost",
		"database"=>"dbarticles"
	);
	// identit de l'utilisateur
	$sUser="st";
  $sMdp="st";
  
  // ouverture de la session
  $oArticles=new articles($dDSN,$sUser,$sMdp);
  // erreurs ?
  checkErreurs($oArticles);
  // suivi
  echo "Connect  la base...\n";
  echo "administrateur=$oArticles->bAdmin\n";
  
  // liste des articles
  $oArticles->selectArticles(array('colonnes'=>'*'));
  // suivi
  suivi($oArticles);
  // erreurs ?
  checkErreurs($oArticles);
  // contenu
  $rsultats=&$oArticles->oRsultats;
  while ($ligne = $rsultats->fetchRow(DB_FETCHMODE_ASSOC)) {
    echo $ligne['code'].",",$ligne['nom'].",".$ligne['prix'].",".$ligne['stockActuel'].",".$ligne['stockMinimum']."\n";
  }//while

	// suppression d'une ligne
  $oArticles->deleteArticle('xxxx');
  // suivi
  suivi($oArticles);
  // erreurs ?
  checkErreurs($oArticles);
    
  // ajout d'une ligne
  $oArticles->addArticle(array('code'=>'xxxx','nom'=>'vlo','prix'=>300,'stockActuel'=>10,'stockMinimum'=>5));
  // suivi
  suivi($oArticles);  
	// erreurs ?
  checkErreurs($oArticles);

  // liste des articles
  $oArticles->selectArticles(array('colonnes'=>'*'));
  // suivi
  suivi($oArticles);  
  // erreurs ?
  checkErreurs($oArticles);
  // contenu
  $rsultats=&$oArticles->oRsultats;
  while ($ligne = $rsultats->fetchRow(DB_FETCHMODE_ASSOC)) {
    echo $ligne['code'].",",$ligne['nom'].",".$ligne['prix'].",".$ligne['stockActuel'].",".$ligne['stockMinimum']."\n";
  }//while

  // modification d'une ligne
  $oArticles->modifyArticle(array('code'=>'xxxx','nom'=>'vlo','prix'=>400,'stockActuel'=>10,'stockMinimum'=>5));
  // suivi
  suivi($oArticles);  
	// erreurs ?
  checkErreurs($oArticles);

  // liste des articles
  $oArticles->selectArticles(array('colonnes'=>'*'));
  // suivi
  suivi($oArticles);  
  // erreurs ?
  checkErreurs($oArticles);
  // contenu
  $rsultats=&$oArticles->oRsultats;
  while ($ligne = $rsultats->fetchRow(DB_FETCHMODE_ASSOC)) {
    echo $ligne['code'].",",$ligne['nom'].",".$ligne['prix'].",".$ligne['stockActuel'].",".$ligne['stockMinimum']."\n";
  }//while

	// existence d'un article
  $sCode="xxxx";
  $trouv=$oArticles->existeArticle($sCode);
  // suivi
  suivi($oArticles);
  if($trouv) echo "L'article de code [$sCode] existe\n";
  	else echo "L'article de code [$sCode] n'existe pas \n";

	// suppression d'une ligne
  $oArticles->deleteArticle('xxxx');
  // suivi
  suivi($oArticles);
  // erreurs ?
  checkErreurs($oArticles);
    
	// existence d'un article
  $sCode="xxxx";
  $trouv=$oArticles->existeArticle($sCode);
  // suivi
  suivi($oArticles);
  if($trouv) echo "L'article de code [$sCode] existe\n";
  	else echo "L'article de code [$sCode] n'existe pas \n";

  // une requte d'administration
  $requte="select users.login,droits.table,droits.ajouter,droits.modifier,droits.supprimer,droits.consulter ".
  	"from users,droits where users.login=droits.login";
  // excution
  $oArticles->execute($requte,FALSE);
  // suivi
  suivi($oArticles);
  // erreurs ?
  checkErreurs($oArticles);
  // contenu
  $rsultats=&$oArticles->oRsultats;
  while ($ligne = $rsultats->fetchRow(DB_FETCHMODE_ASSOC)) {
    echo $ligne['login'].",",$ligne['table'].",".$ligne['ajouter'].",".$ligne['modifier'].",".$ligne['supprimer'].",".$ligne['consulter']."\n";
  }//while
  	
  // on se dconnecte
  $oArticles->disconnect();
  // suivi
  echo "Dconnect de la base...\n";

  // nouvel utilisateur
	// identit de l'utilisateur
	$sUser="user1";
  $sMdp="user1";

  // ouverture de la session
  $oArticles=new articles($dDSN,$sUser,$sMdp);
  // erreurs ?
  checkErreurs($oArticles);
  // suivi
  echo "Connect  la base...\n";
  echo "administrateur=$oArticles->bAdmin\n";
  
  // une requte d'administration
  $requte="select users.login,droits.table,droits.ajouter,droits.modifier,droits.supprimer,droits.consulter ".
  	"from users,droits where users.login=droits.login";
  // excution
  $oArticles->execute($requte,FALSE);
  // suivi
  suivi($oArticles);
  // erreurs ?
  checkErreurs($oArticles);

  // on se dconnecte
  $oArticles->disconnect();
  // suivi
  echo "Dconnect de la base...\n";
  
  // fin
  exit(0);
  
  // ----------------------------------
  function checkErreurs(&$oArticles){
  	// des erreurs ?
    if(count($oArticles->aErreurs)!=0){
    	// affichage
      for($i=0;$i<count($oArticles->aErreurs);$i++){
      	echo $oArticles->aErreurs[$i]."\n";
      }//for
      // fin
      if ($oArticles->connect) $oArticles->disconnect();
      echo "Abandon. Dconnexion de la base";
      exit(1);
    }//if
  }//checkErreurs  

	// -----------------------------------
  function suivi(&$oArticles){
  	// affiche la dernire requte excute
    echo "--> ".$oArticles->sQuery."\n";
  }//suivi    
?>     
